import * as i0 from '@angular/core';
import { Injectable } from '@angular/core';
import { createZoomImageClick, createZoomImageHover, createZoomImageMove, createZoomImageWheel } from '@zoom-image/core';
import { BehaviorSubject } from 'rxjs';

class ZoomImageClickService {
    constructor() {
        this._zoomImageState = new BehaviorSubject({
            zoomedImgStatus: "idle",
        });
        this.zoomImageState$ = this._zoomImageState.asObservable();
        this.zoomImageState = this._zoomImageState.value;
        this.createZoomImage = (...arg) => {
            this.result?.cleanup();
            this.result = createZoomImageClick(...arg);
            this.result.subscribe(({ state }) => {
                this._zoomImageState.next(state);
            });
        };
    }
    ngOnDestroy() {
        this.result?.cleanup();
    }
    static { this.ɵfac = function ZoomImageClickService_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || ZoomImageClickService)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: ZoomImageClickService, factory: ZoomImageClickService.ɵfac }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ZoomImageClickService, [{
        type: Injectable
    }], null, null); })();

class ZoomImageHoverService {
    constructor() {
        this._zoomImageState = new BehaviorSubject({
            enabled: false,
            zoomedImgStatus: "idle",
        });
        this.zoomImageState$ = this._zoomImageState.asObservable();
        this.zoomImageState = this._zoomImageState.value;
        this.createZoomImage = (...arg) => {
            this.result?.cleanup();
            this.result = createZoomImageHover(...arg);
            this.result.subscribe(({ state }) => {
                this._zoomImageState.next(state);
            });
        };
        this.setZoomImageState = (state) => {
            this.result?.setState(state);
        };
    }
    ngOnDestroy() {
        this.result?.cleanup();
    }
    static { this.ɵfac = function ZoomImageHoverService_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || ZoomImageHoverService)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: ZoomImageHoverService, factory: ZoomImageHoverService.ɵfac }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ZoomImageHoverService, [{
        type: Injectable
    }], null, null); })();

class ZoomImageMoveService {
    constructor() {
        this._zoomImageState = new BehaviorSubject({
            zoomedImgStatus: "idle",
        });
        this.zoomImageState$ = this._zoomImageState.asObservable();
        this.zoomImageState = this._zoomImageState.value;
        this.createZoomImage = (...arg) => {
            this.result?.cleanup();
            this.result = createZoomImageMove(...arg);
            this.result.subscribe(({ state }) => {
                this._zoomImageState.next(state);
            });
        };
    }
    ngOnDestroy() {
        this.result?.cleanup();
    }
    static { this.ɵfac = function ZoomImageMoveService_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || ZoomImageMoveService)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: ZoomImageMoveService, factory: ZoomImageMoveService.ɵfac }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ZoomImageMoveService, [{
        type: Injectable
    }], null, null); })();

class ZoomImageWheelService {
    constructor() {
        this._zoomImageState = new BehaviorSubject({
            currentZoom: 1,
            enable: false,
            currentPositionX: -1,
            currentPositionY: -1,
            currentRotation: 0,
        });
        this.zoomImageState$ = this._zoomImageState.asObservable();
        this.zoomImageState = this._zoomImageState.value;
        this.createZoomImage = (...arg) => {
            this.result?.cleanup();
            this.result = createZoomImageWheel(...arg);
            this.result.subscribe(({ state }) => {
                this._zoomImageState.next(state);
            });
        };
    }
    setZoomImageState(state) {
        this.result?.setState(state);
    }
    ngOnDestroy() {
        this.result?.cleanup();
    }
    static { this.ɵfac = function ZoomImageWheelService_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || ZoomImageWheelService)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: ZoomImageWheelService, factory: ZoomImageWheelService.ɵfac }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ZoomImageWheelService, [{
        type: Injectable
    }], null, null); })();

/**
 * Generated bundle index. Do not edit.
 */

export { ZoomImageClickService, ZoomImageHoverService, ZoomImageMoveService, ZoomImageWheelService };
//# sourceMappingURL=zoom-image-angular.mjs.map
